/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.table;

import cn.ac.ios.util.Pair;

public class HashableValueBooleanPair implements HashableValue {
	
	private boolean valueLeft, valueRight ;
	
	public HashableValueBooleanPair(boolean left, boolean right) {
		this.valueLeft  = left;
		this.valueRight = right;
	}

	@Override
	public boolean valueEqual(HashableValue rvalue) {
		return valueLeft == (Boolean)rvalue.getLeft()
			&& valueRight == (Boolean)rvalue.getRight();
	}

	@SuppressWarnings("unchecked")
	@Override
	public Pair<Boolean, Boolean> get() {
		return new Pair<>(valueLeft, valueRight);
	}
	
	public boolean equals(Object obj) {
		if(obj instanceof HashableValueBooleanPair) {
			HashableValueBooleanPair pair = (HashableValueBooleanPair)obj;
			return valueEqual(pair);
		}
		return false;
	}
	
	public String toString() {
		return "(" +  (valueLeft ? "+" : "-")
				+ ", " + (valueRight ? "+" : "-") + ")";
	}
	
	public int hashCode() {
		int value = valueLeft ? 0 : 1;
		value = value * 2 + (valueRight ? 0 : 1);
		return value;
	}

	@Override
	public boolean isPair() {
		return true;
	}

	@SuppressWarnings("unchecked")
	@Override
	public Boolean getLeft() {
		return valueLeft;
	}

	@SuppressWarnings("unchecked")
	@Override
	public Boolean getRight() {
		return valueRight;
	}

	@Override
	public boolean isAccepting() {
		return valueLeft && valueRight ;
	}

}
